//     
// UpdatingStarted -  
// UpdatingProgress -    
// UpdatingFinished -   

function vk_Feed2()
{
    this.vk_Log( 10, "vk_Feed2", "()" );
}

vk_Feed2.prototype.Init = function()
{
    this.vk_Log( 9, "vk_Feed2", "Init()" );

    //    vk_Info 
    this.info_new = new vk_Info();
    this.info_new.Init();
    this.info_new.InitData();

    this.info_new_complete = false;

    this.feed2_mask =
    {
        user: "user",
        counters: "counters",
        services: "services",
        status: "activity",

        friends: 1,
        photos: 2,
        videos: 4,
        messages: 8,
        notes: 16,
        groups: 32,
        meetings: 64,

        offers: 128,
        opinions: 256,
        questions: 512,
        gifts: 1024
    };

    this.requests =
    {
        index: 0, //      list
        list: [ "feed2", "feed2_ex" ], //        
        redirected: false,
        stopped: false,
        
        headers_default:
        {
            // ,    ,     
            "If-Modified-Since": "Sat, 1 Jan 2000 00:00:00 GMT",
            "Pragma": "no-cache",
            "Cache-Control": "no-cache"
        },
        headers_additional: {},

        feed2: vk_global.prefs.urls.feed2 + "?nokia=1" + "&act=" + this.feed2_mask.counters + "|" + this.feed2_mask.services,
        feed2_ex: ""
    };

    this.updating = false;

    this.observer_service = vk_global.observer_service;

    this.initialized = true;

    this.html_provider = new vk_HTMLProvider();
    this.html_provider.Init
    (
        vk_callback( this, "OnRequestComplete" ),
        vk_callback( this, "OnRequestFailure" ),
        vk_global.prefs.requests.timeout,
        vk_global.prefs.urls.main
    );
    this.html_provider.AddResponseStatusHandler( 302, vk_callback( this, "OnRequestRedirect" ) );

    this.html_parser = new vk_HTMLParser();
    this.html_parser.Init( this.info_new );

    this.timer = undefined;
}

vk_Feed2.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_Feed2", "Destroy()" );

    this.Stop();
    this.initialized = false;

    this.observer_service = undefined;
}

//        
vk_Feed2.prototype.Start = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "Start()" );

    if ( this.timer == undefined )
    {
        this.timer = vk_setInterval( vk_callback( this, "StartUpdate" ), vk_global.prefs.update.interval * 1000 );
        this.StartUpdate();
    }
}

//     
vk_Feed2.prototype.Stop = function()
{
    this.vk_Log( (this.initialized ? 7 : 5), "vk_Feed2", "Stop()" );

    if ( this.timer != undefined )
    {
        vk_clearInterval( this.timer );
        this.timer = undefined;
    }

    if ( !this.requests.stopped && this.updating )
        this.StopUpdate();
}

vk_Feed2.prototype.StartUpdate = function( force )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "StartUpdate()" );

    if ( !this.initialized ) return;

    //   ,  
    if ( !vk_global.prefs.behavior.turn_on ) return;

    //        ,  
    if ( this.updating ) return;

    //      
    vk_global.state.UpdateLoginState();

    if ( !vk_global.state.logged_in ) return;

    if ( !force )
    {
        //       ,         3/4   
        var time_left = ( new Date() ).getTime() - vk_global.info.updated_at;
        this.vk_Log( 8, "vk_Feed2", "StartUpdate: time_left=" + (time_left/1000) + " seconds" );
        if ( time_left < ( (vk_global.prefs.update.interval * 1000) * 3/4 ) )
            return;
    }

    this.updating = true;

    this.requests.index = 0;
    this.requests.redirected = false;
    this.requests.stopped = false;

    this.Notify_( "UpdatingStarts" );

    this.info_new_complete = false;

    this.Request_();
}

vk_Feed2.prototype.StopUpdate = function()
{
    this.vk_Log( (this.initialized ? 7 : 5), "vk_Feed2", "StopUpdate()" );

    if ( this.updating && !this.requests.stopped )
    {
        this.requests.stopped = true;
        this.html_provider.Abort();
    }
}

vk_Feed2.prototype.SetHeaders = function( headers )
{
    this.requests.headers_additional = headers;
}

vk_Feed2.prototype.UpdatingContinue_ = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "UpdatingContinue_()" );

    this.requests.index++;
    this.requests.redirected = false;

    this.Notify_( "UpdatingProgress", Math.round( 100 * this.requests.index / this.requests.list.length ) );

    if ( this.requests.index == this.requests.list.length )
        this.BeforeUpdatingFinish_();
    else
        this.Request_();
}

vk_Feed2.prototype.BeforeUpdatingFinish_ = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "BeforeUpdatingFinish_()" );

    if ( this.requests.stopped )
        this.AfterUpdatingFinish_();
    else
    {
        if ( this.info_new_complete )
            vk_global.info.Update( this.info_new );

        vk_setTimeout( vk_callback( this, "AfterUpdatingFinish_" ), vk_global.prefs.gui.finish_update_delay );
    }
}

vk_Feed2.prototype.AfterUpdatingFinish_ = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "AfterUpdatingFinish_()" );

    if ( !this.initialized ) return;

    this.Notify_( "UpdatingFinish" );

    this.updating = false;
}

vk_Feed2.prototype.Request_ = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "Request_(), request=" + this.requests.list[ this.requests.index ] );

    switch ( this.requests.list[ this.requests.index ] )
    {
        case "feed2":
            break;
        case "feed2_ex":
        {
            if ( this.requests.feed2_ex == "" )
            {
                this.UpdatingContinue_();
                return;
            }
        }
    }

    var headers = new Object();
    for ( var i in this.requests.headers_default )
        headers[i] = this.requests.headers_default[i];
    for ( var i in this.requests.headers_additional )
        headers[i] = this.requests.headers_additional[i];

    this.html_provider.HTTPRequest( this.requests[ this.requests.list[ this.requests.index ] ], "GET", headers );
}

vk_Feed2.prototype.Parse_ = function( text )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "Parse_(), request=" + this.requests.list[ this.requests.index ] );

    switch ( this.requests.list[ this.requests.index ] )
    {
        case "feed2":
        {
            this.requests.feed2_ex = "";

            var result = this.html_parser.ParseFeed2( text );

            //       
            if ( result == 0 )
            {
                var is_need_request = false;
                var cur_mask = 0;
                var feed2_ex_url;
                var elem;

                feed2_ex_url = this.requests.feed2;

                if ( (vk_global.info.user.id != -1) && (vk_global.info.user.id != this.info_new.user.id) )
                    vk_global.info.InitData();

                if ( vk_global.info.status.updated_at != this.info_new.status.updated_at )
                {
                    feed2_ex_url += "|" + this.feed2_mask.status;
                    is_need_request = true;
                }

                if ( !(vk_global.info.user.extended_complete) )
                {
                    feed2_ex_url += "|" + this.feed2_mask.user;
                    is_need_request = true;
                }
/*
                for ( var i = 0, elem; elem = vk_global.info.main_info_list[i]; i++ )
                {
                    if (
                        ( "count" in this.info_new[elem] )
                        && ( this.info_new[elem].count != 0 )
                        && ( "extended_complete" in vk_global.info[elem] )
                        //    ,      
                        && (
                            !vk_global.info[elem].extended_complete
                            || (vk_global.info[elem].count != this.info_new[elem].count)
                        )
                    )
                    {
                        cur_mask += this.feed2_mask[elem];
                        is_need_request = true;
                    }
                }
*/
                if ( cur_mask > 0 )
                    feed2_ex_url += "&mask=" + cur_mask;

                if ( is_need_request )
                {
                    this.requests.feed2_ex = feed2_ex_url;
                }
                else
                {
                    this.info_new.extended_complete = true;
                }

                this.info_new_complete = true;
            }
            else if ( result == 2 )
            {
                this.info_new_complete = true;
            }

            break;
        }
        case "feed2_ex":
        {
            var result = this.html_parser.ParseFeed2( text );
            if ( (result == 0) || (result == 2) )
                this.info_new_complete = true;
            break;
        }
    }
}

vk_Feed2.prototype.Notify_ = function( event, value )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "Notify_()" );

    this.observer_service.notifyObservers( null, "vk_Feed2-" + event, value );
}

vk_Feed2.prototype.OnRequestComplete = function( text )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "OnRequestComplete()" );

    if ( !this.initialized ) return;

    if ( this.requests.stopped )
    {
        this.BeforeUpdatingFinish_();
        return;
    }

    this.Parse_( text );

    this.UpdatingContinue_();
}

vk_Feed2.prototype.OnRequestFailure = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Feed2", "OnRequestFailure()" );

    if ( !this.initialized ) return;

    if ( this.requests.redirected )
        this.info_new.InitData();

    this.BeforeUpdatingFinish_();
}

vk_Feed2.prototype.OnRequestRedirect = function()
{
    this.vk_Log( (this.initialized ? 7 : 5), "vk_Feed2", "OnRequestRedirected()" );

    //      !this.initialized
    // ..       

    this.requests.redirected = true;
    this.html_provider.Abort();
}
