function vk_Info()
{
    this.vk_Log( 10, "vk_Info", "()" );
}

vk_Info.prototype.Init = function()
{
    this.vk_Log( 9, "vk_Info", "Init()" );

    this.allow_notifications = false;

    //     
    this.main_info_list =
    [
        "friends",
        "photos",
        "videos",
        "messages",
        "notes",
        "groups",
        "meetings",
        "offers",
        "opinions",
        "questions",

        "audioes",
        "news",
        "bookmarks",
        "applications",
        "advertisements",

        "wall",
        "gifts"
    ];

    this.observer_service = vk_global.observer_service;

    this.initialized = true;
}

vk_Info.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_Info", "Destroy()" );

    this.initialized = false;

    if ( this.allow_notifications )
        this.observer_service.removeObserver( this, "vk_State" );
}

//  ==  , ,  ..
vk_Info.prototype.InitData = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "InitData()" );

    this.updated_at = 0; //     

    //     
    // true: 1)   true -   extended 
    // true: 2)   false -    (  )
    // false:    (     )
    this.extended_complete = false;

    this.services_complete = false;

    this.user =
    {
        id: -1,
        name: "",
        changed: false,
        logged_in: false,
        extended_complete: false
    };

    this.friends =
    {
        count: 0,
        list: Array(), // [[User Name, User Id]] //        
        changed: false, //        
        increased: false, //        
        extended_complete: false //    list  
    };
    this.photos =
    {
        count: 0,
        list: Array(), // [[User Name, Photos Id]]
        changed: false,
        increased: false,
        extended_complete: false
    };
    this.videos =
    {
        count: 0,
        list: Array(), // [[User Name, Video Id]]
        changed: false,
        increased: false,
        extended_complete: false
    };
    this.messages =
    {
        count: 0,
        list: Array(), // [[User Name, Message Id]]
        changed: false,
        increased: false,
        extended_complete: false
    };
    this.notes =
    {
        count: 0,
        list: Array(), // [[User Name, Note Id]] // TODO:      
        changed: false,
        increased: false,
        extended_complete: false
    };
    this.groups =
    {
        count: 0,
        list: Array(), // [[Group Name, Group Id]]
        changed: false,
        increased: false,
        extended_complete: false
    };
    this.meetings =
    {
        count: 0,
        list: Array(), // [[Meeting Name, Meeting Id]]
        changed: false,
        increased: false,
        extended_complete: false
    };

    this.offers =
    {
        count: 0,
        list: Array(), // [[User Name, User Id]] // User Id -  
        changed: false,
        increased: false,
        extended_complete: false,
        enabled: false
    };
    this.opinions =
    {
        count: 0,
        changed: false,
        increased: false,
        enabled: false
    };
    this.questions =
    {
        count: 0,
        list: Array(), // [[User Name, Question Id]] // TODO:      
        changed: false,
        increased: false,
        extended_complete: false,
        enabled: false
    };

    this.audioes =
    {
        changed: false,
        enabled: false
    };
    this.news =
    {
        changed: false,
        enabled: false
    };
    this.bookmarks =
    {
        changed: false,
        enabled: false
    };
    this.applications =
    {
        changed: false,
        enabled: false
    };
    this.advertisements =
    {
        changed: false,
        enabled: false
    };

    this.wall =
    {
        count: 0,
        changed: false,
        increased: false
    };
    this.gifts =
    {
        count: 0,
        //list: Array(),
        changed: false,
        increased: false
        //extended_complete: false
    };

    this.status =
    {
        updated_at: 0,
        changed: false,
        text: "",
        hash: "",
        extended_complete: false
    };

    this.NotifyAll();
    this.NotifyUpdated_();
}

vk_Info.prototype.observe = function( subject, topic, data )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Prefs", "observe(), subject=" + subject + ", topic=" + topic + ", data=" + data );

    if ( !this.initialized ) return;

    if ( (topic == "vk_State") && (data = "logged_in") && !vk_global.state.logged_in )
        this.InitData();
}

vk_Info.prototype.AllowNotifications = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "AllowNotifications()" );

    if ( !this.allow_notifications )
    {
        this.allow_notifications = true;

        this.observer_service.addObserver( this, "vk_State", false );
    }
}

vk_Info.prototype.Update = function( info_new )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "Update()" );

    //   ,  
    var updated = new Object();

    //   ,        
    if ( (this.user.id != -1) && (this.user.id != info_new.user.id) )
        this.InitData();

    this.user.changed = ( this.user.id != info_new.user.id );
    this.user.id = info_new.user.id;
    this.user.logged_in = ( this.user.id != -1 );

    if ( !this.user.logged_in )
        return;

    if ( info_new.services_complete )
    {
        this.services = info_new.services;
        this.services_complete = info_new.services_complete;
    }

    // Status
    //////////
    this.status.changed = (info_new.status.updated_at != this.status.updated_at);
    this.status.updated_at = info_new.status.updated_at;

    if ( info_new.status.extended_complete )
    {
        this.status.text = info_new.status.text;
        this.status.hash = info_new.status.hash;
        this.status.extended_complete = info_new.status.extended_complete;
    }
    else
    {
        if ( this.status.changed )
        {
            this.status.text = "";
            this.status.extended_complete = false;
        }
    }
    
    if ( this.status.changed || info_new.status.extended_complete )
        updated["status"] = true;
    //////////

    this.extended_complete = info_new.extended_complete;

    //    
    if ( info_new.extended_complete )
    {
        //     ,    
        if ( info_new.user.extended_complete )
        {
            this.user.extended_complete = info_new.user.extended_complete;
            this.user.name = info_new.user.name;
        }
    }

    //       ,     
    if ( this.user.changed || info_new.user.extended_complete )
        updated["user"] = true;

    for ( var i = 0, elem; elem = this.main_info_list[i]; i++ )
    {
        //   
        this.UpdateOne_( this[elem], info_new[elem], info_new.services_complete );

        //      ,    
        // (      ),     
        if ( this[elem].changed || (("extended_complete" in info_new[elem]) && info_new[elem].extended_complete) )
            updated[elem] = true;
    }

    this.updated_at = ( new Date() ).getTime();

    for ( var i in updated )
        this.Notify_( i );

    //  - ,    
    for ( var i in updated )
    {
        this.NotifyUpdated_();
        break;
    }
}

vk_Info.prototype.UpdateOne_ = function( cur_info_item, new_info_item, services_complete )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "UpdateOne_()" );

    if ( "count" in cur_info_item )
    {
        cur_info_item.changed = ( new_info_item.count != cur_info_item.count );
        cur_info_item.increased = ( new_info_item.count > cur_info_item.count );
        cur_info_item.count = new_info_item.count;

        //       
        if ( "extended_complete" in cur_info_item )
        {
            if ( cur_info_item.count == 0 )
            {
                //      ,     
                cur_info_item.extended_complete = true;
                cur_info_item.list = new_info_item.list;
            }
            else
            {
                //    
                if ( this.extended_complete )
                {
                    //      ,   
                    if ( new_info_item.extended_complete )
                    {
                        cur_info_item.list = new_info_item.list;

                        if ( new_info_item.list.length != 0 )
                            cur_info_item.extended_complete = new_info_item.extended_complete;
                        else
                            cur_info_item.extended_complete = false;
                    }
                }
                else
                {
                    //    ,       
                    if ( cur_info_item.changed )
                    {
                        cur_info_item.extended_complete = new_info_item.extended_complete;
                        cur_info_item.list = new_info_item.list;
                    }
                }
            }
        }
    }
    else
        cur_info_item.changed = false;

    if ( services_complete && ("enabled" in cur_info_item) )
    {
        cur_info_item.changed = ( cur_info_item.changed || (new_info_item.enabled != cur_info_item.enabled) );
        cur_info_item.enabled = new_info_item.enabled;
    }
}

vk_Info.prototype.Notify_ = function( event )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "Notify_()" );

    if ( this.allow_notifications )
        this.observer_service.notifyObservers( null, "vk_Info", event );
}

vk_Info.prototype.NotifyUpdated_ = function( event )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "NotifyUpdated_()" );

    if ( this.allow_notifications )
        this.observer_service.notifyObservers( null, "vk_Info-Updated", event );
}

vk_Info.prototype.NotifyAll = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_Info", "NotifyAll()" );

    this.Notify_( "user" );
    this.Notify_( "status" );

    for ( var i = 0, elem; elem = this.main_info_list[i]; i++ )
        this.Notify_( elem );
}
