function vk_State()
{
    this.vk_Log( 10, "vk_State", "()" );
}

vk_State.prototype.Init = function()
{
    this.vk_Log( 9, "vk_State", "Init()" );

    if ( vk_engine.gecko )
        this.logged_in = false;
    else ( vk_engine.webkit )
        this.logged_in = true;

    this.windows_count = 0;

    this.observer_service = vk_global.observer_service;

    this.initialized = true;
}

vk_State.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_State", "Destroy()" );

    this.initialized = false;

    this.observer_service = undefined;
}

//  cookie        
vk_State.prototype.UpdateLoginState = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_State", "UpdateLoginState()" );

    if ( !this.initialized ) return;

    var last_logged_in = this.logged_in;

    if ( vk_engine.gecko )
    {
        var io_service = Components.classes[ "@mozilla.org/network/io-service;1" ]
            .getService( Components.interfaces.nsIIOService );
        var uri = io_service.newURI( vk_global.prefs.urls.main, null, null );
        var cookie_service = Components.classes[ "@mozilla.org/cookieService;1" ]
            .getService( Components.interfaces.nsICookieService );
        var cookie = cookie_service.getCookieString( uri, null );

        if
        (
            ( cookie != undefined ) &&
            ( cookie.match( /remixmid=\d+(;|$)/gi ) != null ) &&
            ( cookie.match( /remixemail=[^;]+(;|$)/gi ) != null ) &&
            ( cookie.match( /remixpass=[^;]+(;|$)/gi ) != null )
        )
            this.logged_in = true;
        else
            this.logged_in = false;
    }
    else if ( vk_engine.webkit )
    {
        var id = vk_main.cookie.id;
        var email = vk_main.cookie.email;
        var password = vk_main.cookie.password;
        var sid = vk_main.cookie.sid;

        if ( typeof(widget) == "undefined" )
            this.logged_in = true;
        else
            this.logged_in = (sid ? true : false);

        var headers = new Object();
        if ( this.logged_in )
            headers["Cookie"] = "remixmid=" + id + "; remixemail=" + email + "; remixpass=" + password + "; remixsid=" + sid;

        vk_global.feed2.SetHeaders( headers );
    }

    if ( this.logged_in != last_logged_in )
        this.observer_service.notifyObservers( null, "vk_State", "logged_in" );
}
