function vk_Test()
{
    this.vk_Log( 10, "vk_Test", "()" );
}

vk_Test.prototype.Init = function()
{
    this.vk_Log( 9, "vk_Test", "Init()" );

    this.observer_service = vk_global.observer_service;

    this.observer_service.addObserver( this, "vk_State", false );
    this.observer_service.addObserver( this, "vk_Info", false );
    this.observer_service.addObserver( this, "vk_Info-Updated", false );
    this.observer_service.addObserver( this, "vk_Feed2-UpdatingStarted", false );
    this.observer_service.addObserver( this, "vk_Feed2-UpdatingProgress", false );
    this.observer_service.addObserver( this, "vk_Feed2-UpdatingFinished", false );

    this.initialized = true;
}

vk_Test.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_Test", "Destroy()" );

    this.initialized = false;

    this.observer_service.removeObserver( this, "vk_State" );
    this.observer_service.removeObserver( this, "vk_Info" );
    this.observer_service.removeObserver( this, "vk_Info-Updated" );
    this.observer_service.removeObserver( this, "vk_Feed2-UpdatingStarted" );
    this.observer_service.removeObserver( this, "vk_Feed2-UpdatingProgress" );
    this.observer_service.removeObserver( this, "vk_Feed2-UpdatingFinished" );

    this.observer_service = undefined;
}

vk_Test.prototype.observe = function( subject, topic, data )
{
    if ( !this.initialized )
        this.vk_Log( 5, "vk_Test", "observe(), subject=" + subject + ", topic=" + topic + ", data=" + data );

    if ( !this.initialized ) return;

    if ( topic == "vk_Info" )
    {
        if ( data == "user" )
            this.vk_Log( 7, "vk_Test", "observe(), vk_global.info.user.id=" + vk_global.info.user.id );
        else if ( data == "status" )
            this.vk_Log( 7, "vk_Test", "observe(), vk_global.info.status={updated_at=" + vk_global.info.status.updated_at + "}" );
        else
        {
            var count_str = "";
            var enabled_str = "";

            if ( "count" in vk_global.info[data] )
                count_str += "count=" + vk_global.info[data].count;

            if ( "enabled" in vk_global.info[data] )
            {
                if ( count_str != "" )
                    enabled_str = ", ";

                enabled_str += "enabled=" + vk_global.info[data].enabled;
            }


            this.vk_Log( 7, "vk_Test", "observe(), vk_global.info." + data + "={" + count_str + enabled_str + "}" );
        }
        return
    }

    if ( topic == "vk_State" )
    {
        this.vk_Log( 7, "vk_Test", "observe(), vk_global.state.logged_in=" + vk_global.state.logged_in );
        return;
    }

    this.vk_Log( 7, "vk_Test", "observe(), subject=" + subject + ", topic=" + topic + ", data=" + data );
}
