var vk_DEBUG = true;// true, false

var vk_consts =
{
    CALL_DELAY: 100
};

// vk_engine

var vk_engine =
{
    gecko: false,
    webkit: false
};

if ( (typeof(Components) != "undefined")
    && ("classes" in Components)
    && ("interfaces" in Components) )
{
    vk_engine.gecko = true;
}
else if ( (typeof(console) != "undefined")
    && ("info" in console))
{
    vk_engine.webkit = true;
}

// vk_dump

var vk_dump;

if ( typeof(dump) != "undefined" )
{
    vk_dump = function vk_dump( text ) { dump( text ); }
}
else if ( (typeof(console) != "undefined") && ("info" in console) )
{
    vk_dump = function vk_dump( text ) { console.info( text ); }
}
else
{
    vk_dump = function vk_dump( text ) {}
}

// vk_callback

function vk_callback( obj, func_name_str )
{
    if ( !(func_name_str in obj) )
    {
        var error_str = "[vk] Wrong callback=\"" + func_name_str + "\"\n";
        vk_dump( error_str );
        throw error_str;
    }

    if ( arguments.length > 2 )
    {
        var arguments_ = new Array();
        for ( var i = 0, len = arguments.length; i < len - 2; i++ )
            arguments_[i] = arguments[i + 2];

        return function()
        {
            obj[func_name_str].apply( obj, arguments_ );
        }
    }
    else
    {
        return function()
        {
            obj[func_name_str].apply( obj, arguments );
        }
    }
}

// vk_setTimeout, vk_clearTimeout, vk_setInterval, vk_clearInterval

var vk_setTimeout;
var vk_clearTimeout;
var vk_setInterval;
var vk_clearInterval;

if ( vk_engine.gecko && ("nsITimer" in Components.interfaces) )
{
    // FF3: Timers that are initiated using setTimeout() are now blocked by modal windows due to the fix made for bug 52209. You may use nsITimer instead.
    vk_setTimeout = function vk_setTimeout( func, timeout )
    {
        var timer = Components.classes[ "@mozilla.org/timer;1" ]
            .createInstance( Components.interfaces.nsITimer );

        var obj = new function()
        {
            this.observe = function()
            {
                func();
            }
        }

        timer.init( obj, timeout, timer.TYPE_ONE_SHOT );

        return timer;
    }

    vk_clearTimeout = function vk_clearTimeout( timer )
    {
        timer.cancel();
    }

    vk_setInterval = function vk_setInterval( func, interval )
    {
        var timer = Components.classes[ "@mozilla.org/timer;1" ]
            .createInstance( Components.interfaces.nsITimer );

        var obj = new function()
        {
            this.observe = function()
            {
                func();
            }
        }

        timer.init( obj, interval, timer.TYPE_REPEATING_PRECISE );

        return timer;

    }

    vk_clearInterval = function vk_clearInterval( timer )
    {
        timer.cancel();
    }
}
else if ( (typeof(setTimeout) != "undefined")
    && (typeof(clearTimeout) != "undefined")
    && (typeof(setInterval) != "undefined")
    && (typeof(clearInterval) != "undefined") )
{
    vk_setTimeout = function vk_setTimeout( func, timeout )    { return setTimeout( func, timeout ); }
    vk_clearTimeout = function vk_clearTimeout( id )           { clearTimeout( id ); }
    vk_setInterval = function vk_setInterval( func, interval ) { return setInterval( func, interval ); }
    vk_clearInterval = function vk_clearInterval( id )         { clearInterval( id ); }
}
else
{
    var error_str = "[vk] vk_setTimeout, vk_clearTimeout, vk_setInterval, vk_clearInterval functions are not defined\n";
    vk_dump( error_str );
    throw error_str;
}

// vk_Log

var vk_Log;

if ( vk_DEBUG )
{
    vk_Log = function vk_Log( severity_level, class_name, message )
    {
        switch ( class_name )
        {
            case "vk_GUI":
                if ( severity_level > 8 ) return;
                break;
            case "vk_Feed2":
            case "vk_State":
            case "vk_HTMLParser":
            case "vk_DOMParser":
            case "vk_Test":
            case "vk_HTMLProvider":
            case "vk_ObserverService":
            case "vk_RequestQueue":
            case "vk_Info":
            case "vk_Main":
            case "vk_Prefs":
            case "vk_UserNotification":
                if ( severity_level > 5 ) return;
                break;
            default:
                // 0 -  
                if ( severity_level > 5 ) return;
        }


        var date = new Date();
        var hours = date.getHours();
        var minutes = date.getMinutes();
        var seconds = date.getSeconds();
        var milliseconds = date.getMilliseconds();

        if ( hours < 10 ) hours = "0" + hours;
        if ( minutes < 10 ) minutes = "0" + minutes;
        if ( seconds < 10 ) seconds = "0" + seconds;
        if ( milliseconds < 10 )
            milliseconds = "00" + milliseconds;
        else if ( milliseconds < 100 )
            milliseconds = "0" + milliseconds;

        var time = hours + ":" + minutes + ":" + seconds + "." + milliseconds;

        vk_dump( "[vk] (" + time + ") " + class_name + "." + message + "\n" );
    }
}
else
{
    vk_Log = function vk_Log( severity_level, class_name, message ) {}
}

if ( typeof(vk_ObserverService) != "undefined" )  vk_ObserverService.prototype.vk_Log = vk_Log;
if ( typeof(vk_Test) != "undefined" )             vk_Test.prototype.vk_Log = vk_Log;
if ( typeof(vk_Info) != "undefined" )             vk_Info.prototype.vk_Log = vk_Log;
if ( typeof(vk_State) != "undefined" )            vk_State.prototype.vk_Log = vk_Log;
if ( typeof(vk_DOMParser) != "undefined" )        vk_DOMParser.prototype.vk_Log = vk_Log;
if ( typeof(vk_Feed2) != "undefined" )            vk_Feed2.prototype.vk_Log = vk_Log;
if ( typeof(vk_GUI) != "undefined" )              vk_GUI.prototype.vk_Log = vk_Log;
if ( typeof(vk_HTMLParser) != "undefined" )       vk_HTMLParser.prototype.vk_Log = vk_Log;
if ( typeof(vk_HTMLProvider) != "undefined" )     vk_HTMLProvider.prototype.vk_Log = vk_Log;
if ( typeof(vk_RequestQueue) != "undefined" )     vk_RequestQueue.prototype.vk_Log = vk_Log;
if ( typeof(vk_Main) != "undefined" )             vk_Main.prototype.vk_Log = vk_Log;
if ( typeof(vk_Prefs) != "undefined" )            vk_Prefs.prototype.vk_Log = vk_Log;
if ( typeof(vk_UserNotification) != "undefined" ) vk_UserNotification.prototype.vk_Log = vk_Log;
