function vk_HTMLParser()
{
    this.vk_Log( 10, "vk_HTMLParser", "()" );
}

vk_HTMLParser.prototype.Init = function( info )
{
    this.vk_Log( 9, "vk_HTMLParser", "Init()" );

    this.info = info;

    this.info_map =
    {
        user: "user",

        wall: "wall",
        friends: "friends",
        photos: "photos",
        videos: "videos",
        messages: "messages",
        notes: "notes",
        groups: "groups",
        meetings: "events",

        offers: "offers",
        opinions: "opinions",
        questions: "questions"
    }
}

vk_HTMLParser.prototype.UnescapeHTML = function( text )
{
    this.vk_Log( 10, "vk_HTMLParser", "UnescapeHTML()" );

    if ( vk_engine.gecko )
    {
        var unescape_service = Components.classes[ "@mozilla.org/feed-unescapehtml;1" ]
            .getService( Components.interfaces.nsIScriptableUnescapeHTML );

        return unescape_service.unescape( text );
    }
    else
    {
        var dom_parser = new vk_DOMParser();
        var doc = dom_parser.Parse( text );
        var text_new = doc.documentElement.innerHTML;

        text_new = this.UnescapeHTMLLight( text_new )
        return text_new;
    }
}

vk_HTMLParser.prototype.UnescapeHTMLLight = function( text )
{
    this.vk_Log( 10, "vk_HTMLParser", "UnescapeHTMLLight()" );

    var text_new;

    text_new = text;
    text_new = text_new.replace( /&lt;/g, "<" );
    text_new = text_new.replace( /&gt;/g, ">" );
    text_new = text_new.replace( /&nbsp;/g, " " );
    text_new = text_new.replace( /&amp;/g, "&" );
    return text_new;
}

// return values: 0 - success, 1 - failed to parse JSON, 2 - not logged in, 3 - other problems
vk_HTMLParser.prototype.ParseFeed2 = function( text )
{
    this.vk_Log( 10, "vk_HTMLParser", "ParseFeed2()" );

    var new_feed2_info;

    //    -  
    var extended_complete = false;

    try
    { new_feed2_info = vk_ParseJSON( text ); }
    catch (e)
    { return 1; }

    this.info.InitData();

    if ( ("user" in new_feed2_info) && ("id" in new_feed2_info.user) && (new_feed2_info.user.id == -1) )
        return 2;

    if ( !("user" in new_feed2_info) )
        return 3;

    if ( "id" in new_feed2_info.user )
    {
        this.info.user.id = new_feed2_info.user.id;
        this.info.user.logged_in = (this.info.user.id != -1);
    }
    else
        return 3;

    if ( "name" in new_feed2_info.user )
    {
        this.info.user.name = this.UnescapeHTML( new_feed2_info.user.name );
        this.info.user.extended_complete = true;
        extended_complete = true;
    }

    if ( ("enabled_services" in new_feed2_info) && (typeof(new_feed2_info.enabled_services) == "number") )
    {
        var services = new_feed2_info.enabled_services;

        if ( services & 1 )
            this.info.news.enabled = true;
        if ( services & 2 )
            this.info.audioes.enabled = true;
        if ( services & 4 )
            this.info.bookmarks.enabled = true;
        if ( services & 8 )
            this.info.opinions.enabled = true;
        if ( services & 16 )
            this.info.offers.enabled = true;
        if ( services & 32 )
            this.info.applications.enabled = true;
        if ( services & 64 )
            this.info.questions.enabled = true;
        if ( services & 256 )
            this.info.advertisements.enabled = true;

        this.info.services_complete = true;
    }

    if (
        ("activity" in new_feed2_info)
        && ("updated" in new_feed2_info.activity)
        && (typeof(new_feed2_info.activity.updated) == "number")
    )
    {
        this.info.status.updated_at = new_feed2_info.activity.updated

        if (
            ("hash" in new_feed2_info.activity)
            && new_feed2_info.activity.hash
            && ("text" in new_feed2_info.activity)
            && new_feed2_info.activity.text
        )
        {
            this.info.status.hash = new_feed2_info.activity.hash;
            this.info.status.text = this.UnescapeHTML( new_feed2_info.activity.text );
            this.info.status.extended_complete = true;
        }
    }

    for ( var i = 0, elem; elem = this.info.main_info_list[i]; i++ )
    {
        if ( (elem in this.info_map) && ("count" in this.info[elem]) && (new_feed2_info[ this.info_map[elem] ]) )
        {
            if ( "count" in new_feed2_info[ this.info_map[elem] ] )
            {
                if ( typeof(new_feed2_info[ this.info_map[elem] ].count) == "number" )
                    this.info[elem].count = new_feed2_info[ this.info_map[elem] ].count;
                else
                    continue;
            }

            if (
                ("extended_complete" in this.info[elem])
                && ("items" in new_feed2_info[ this.info_map[elem] ])
                && new_feed2_info[ this.info_map[elem] ].items
            )
            {
                this.info[elem].list = new Array();

                for ( var j in new_feed2_info[ this.info_map[elem] ].items )
                    this.info[elem].list.push( [ this.UnescapeHTML( new_feed2_info[ this.info_map[elem] ].items[j] ), j ] );

                this.info[elem].extended_complete = true;
                extended_complete = true;
            }
        }
    }

    if ( extended_complete )
        this.info.extended_complete = true;

    //  id     
    //////////
    if ( this.info.videos.extended_complete )
        for ( var i = 0, len = this.info.videos.list.length; i < len; i++ )
            this.info.videos.list[i][1] = this.info.user.id + "_" + this.info.videos.list[i][1];

    if ( this.info.notes.extended_complete )
        for ( var i = 0, len = this.info.notes.list.length; i < len; i++ )
            this.info.notes.list[i][1] = this.info.user.id + "_" + this.info.notes.list[i][1];
    //////////

    return 0;
}
