function vk_ObserverService()
{
    this.vk_Log( 10, "vk_ObserverService", "()" );
}

vk_ObserverService.prototype.Init = function()
{
    this.vk_Log( 9, "vk_ObserverService", "Init()" );

    if ( vk_engine.gecko )
        this.observer_service = Components.classes[ "@mozilla.org/observer-service;1" ]
            .getService( Components.interfaces.nsIObserverService );
    else
        this.observers = new Array();

    this.initialized = true;
}

vk_ObserverService.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_ObserverService", "Destroy()" );

    this.initialized = false;

    if ( vk_engine.gecko )
        this.observer_service = undefined;
}

vk_ObserverService.prototype.addObserver = function( observer, topic, owns_weak )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_ObserverService", "addObserver()" );

    if ( !this.initialized ) return;

    if ( vk_engine.gecko )
        this.observer_service.addObserver( observer, topic, owns_weak );
    else
        this.observers.push( [ topic, observer ] );
}

vk_ObserverService.prototype.removeObserver = function( observer, topic )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_ObserverService", "removeObserver()" );

    if ( !this.initialized ) return;

    if ( vk_engine.gecko )
        this.observer_service.removeObserver( observer, topic );
    else
    {
        for ( var i = 0; i < this.observers.length; i++ )
        {
            if ( (this.observers[i][0] == topic) && (this.observers[i][1] == observer) )
            {
                this.observers.splice( i, 1 );
                break;
            }
        }
    }
}

vk_ObserverService.prototype.notifyObservers = function( subject, topic, some_data )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_ObserverService", "notifyObservers()" );

    if ( !this.initialized ) return;

    if ( vk_engine.gecko )
        this.observer_service.notifyObservers( subject, topic, some_data );
    else
    {
        for ( var i = 0; i < this.observers.length; i++ )
        {
            if ( this.observers[i][0] == topic )
            {
                this.observers[i][1].observe( subject, topic, some_data );
            }
        }
    }
}
