function vk_RequestQueue()
{
    this.vk_Log( 10, "vk_RequestQueue", "()" );
}

vk_RequestQueue.prototype.Init = function()
{
    this.vk_Log( 9, "vk_RequestQueue", "Init()" );

    this.timeout_elapsed = true;

    this.queue = new Array();

    this.initialized = true;
}

vk_RequestQueue.prototype.Destroy = function()
{
    this.vk_Log( 5, "vk_RequestQueue", "Destroy()" );

    this.initialized = false;
}

vk_RequestQueue.prototype.AddRequest = function( request )
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_RequestQueue", "AddRequest()" );

    this.queue.push( request );

    this.ContinueQueue_();
}

vk_RequestQueue.prototype.ContinueQueue_ = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_RequestQueue", "ContinueQueue_()" );

    if ( this.queue.length == 0 )
        return;

    if ( !this.timeout_elapsed )
        return;

    this.timeout_elapsed = false;

    this.queue[0].HTTPRequestFinal();

    this.queue.shift();

    vk_setTimeout( vk_callback( this, "OnTimeoutElapsed" ), vk_global.prefs.requests.interval );
}

vk_RequestQueue.prototype.OnRequestFinished = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_RequestQueue", "OnRequestFinished()" );

    if ( !this.initialized ) return;

    this.ContinueQueue_();
}

vk_RequestQueue.prototype.OnTimeoutElapsed = function()
{
    this.vk_Log( (this.initialized ? 8 : 5), "vk_RequestQueue", "OnTimeoutElapsed()" );

    if ( !this.initialized ) return;

    this.timeout_elapsed = true;

    this.ContinueQueue_();
}
